<?php if(!defined('PLX_ROOT')) exit;
	/**
		* Plugin 			StaticMiniForum
		*
		* @CMS required			PluXml 
		*
		* @version			3.5.2
		* @date				10/03/2025
		* @author 			G.Cyrille
		░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░
		░       ░░  ░░░░░░░  ░░░░  ░  ░░░░  ░░      ░░       ░░░      ░░  ░░░░░░░        ░░      ░░░░░   ░░░  ░        ░        ░
		▒  ▒▒▒▒  ▒  ▒▒▒▒▒▒▒  ▒▒▒▒  ▒▒  ▒▒  ▒▒  ▒▒▒▒  ▒  ▒▒▒▒  ▒  ▒▒▒▒  ▒  ▒▒▒▒▒▒▒▒▒▒  ▒▒▒▒  ▒▒▒▒▒▒▒▒▒▒    ▒▒  ▒  ▒▒▒▒▒▒▒▒▒▒  ▒▒▒▒
		▓       ▓▓  ▓▓▓▓▓▓▓  ▓▓▓▓  ▓▓▓    ▓▓▓  ▓▓▓▓  ▓       ▓▓  ▓▓▓▓  ▓  ▓▓▓▓▓▓▓▓▓▓  ▓▓▓▓▓      ▓▓▓▓▓  ▓  ▓  ▓      ▓▓▓▓▓▓  ▓▓▓▓
		█  ███████  ███████  ████  ██  ██  ██  ████  █  ███████  ████  █  ██████████  ██████████  ████  ██    █  ██████████  ████
		█  ███████        ██      ██  ████  ██      ██  ████████      ██        █        ██      ██  █  ███   █        ████  ████
		█████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████
	**/
	class StaticMiniForum extends plxPlugin {
		
		const BEGIN_CODE = '<?php' . PHP_EOL;
		const END_CODE = PHP_EOL . '?>';
		public $lang = '';
		public $colors = array(
		"colors1" => array("#230571","#8e006d","#0040a4","#00b6b6","#00cbec","#00a777","#ff9300","#d7002c","#eb8096","#f5c0cb"),
		"colors2" => array("#ff3130","#ff8800","#ffca00","#4cd95d","#34b2dc","#0088ff","#a54eca","#e0008e","#757575","#0dff00"),
		"colors3" => array("#802d2f","#ff595e","#ff924c","#ffca3a","#c5ca30","#8ac926","#52a675","#1982c4","#4267ac","#6a4c93"),
		"colors4" => array("#ff595e","#ff924c","#ffca3a","#c5ca30","#8ac926","#52a675","#1982c4","#4267ac","#6a4c93","#d677b8"),
		"colors5" => array("#ff595e","#ff924c","#ffca3a","#c5ca30","#8ac926","#52a675","#1982c4","#4267ac","#6a4c93","#b5a6c9"),
		"colors6" => array("#3646c4","#dd2a18","#23ac07","#241517","#de55aa","#922e1e","#e8cd23","#291465","#1a6a06","#660f0f"),
		"colors7" => array("#ff5959","#ff8922","#e6a800","#2ad607","#00b5d9","#5c59ff","#c900c6","#ff00f2","#7d4545","#080707"),
		"colors8" => array("#16171c","#f7d826","#eb870d","#8804e0","#d4210d","#9c0000","#82e80d","#00ad2b","#36b4fc","#1628cf"),
		"colors9" => array("#ff3c3c","#2e69ff","#0fff1f","#fffb00","#06f7ff","#ad16ff","#ff8cd7","#17dbbb","#ff08a0","#ff9021"),
		);
		public $HTMLletterBadge='<b title="#member" class="badge_miniForum" style="--bgColor:#bgColor;--ftSize:#sizech">#ucWL</b>';
		# Tableau des profils
		public $memberProfils = array();
		public $version = 'V 3.5.2';
		public $moderateSubscription;
		public $datasForums =PLX_ROOT.'data/miniForums/';
		
		
		public function __construct($default_lang) {
			# appel du constructeur de la classe plxPlugin (obligatoire)
			parent::__construct($default_lang);			
			
			# droits pour accèder à la page config.php du plugin
			$this->setConfigProfil(PROFIL_ADMIN, PROFIL_MANAGER);	
			
			$captcha = $this->getParam('captcha') ==''   ?   '0' : $this->getParam('captcha') ;
			$statics = $this->getParam('statics') ==''   ?   '0' : $this->getParam('statics') ;	
			$this->moderateSubscription = $this->getParam('moderateSubscription') ==''   ?   '1' : $this->getParam('moderateSubscription') ;			
			
			# Declaration des hooks		
			$this->addHook('plxMotorPreChauffageEnd','plxMotorPreChauffageEnd');
			$this->addHook('AdminTopBottom', 'AdminTopBottom');
			$this->addHook('AdminTopEndHead', 'AdminTopEndHead');
			$this->addHook('AdminAuthPrepend', 'AdminAuthPrepend');
			$this->addHook('AdminPrepend', 'AdminPrepend');	
			$this->addHook('AdminAuthTop', 'AdminAuthTop');			
			$this->addHook('AdminAuthEndHead', 'AdminAuthEndHead');
			$this->addHook('AdminAuthEndBody', 'AdminAuthEndBody');
			$this->addHook('AdminUsersTop', 'AdminUsersTop');
			$this->addHook('plxShowStaticListEnd', 'plxShowStaticListEnd');
			$this->addHook('ThemeEndHead', 'ThemeEndHead');
			$this->addHook('ThemeEndBody','ThemeEndBody');
			$this->addHook('wizard', 'wizard');
			$this->addHook('plxShowStaticContent', 'plxShowStaticContent');	
			$this->addHook('lastThreads','lastThreads');
			// 'plxShowLastComList'
			$this->memberProfils = array(			
			0 => $this->getLang('L_PROFIL_ADMIN'),
			1 => $this->getLang('L_PROFIL_MANAGER'),
			2 => $this->getLang('L_PROFIL_MODERATOR'),
			3 => $this->getLang('L_PROFIL_EDITOR'),
			4 => $this->getLang('L_PROFIL_WRITER'),
			5 => $this->getLang('L_PROFIL_FORUM')
			);
			if(!file_exists($this->datasForums)) mkdir($this->datasForums, 0744);
		}
		
		
		#code exécuté à la désactivation du plugin
        public function OnDeactivate() {		
			#desactive les comptes visiteurs	
			$deactivateVisitors=simplexml_load_file(PLX_ROOT.PLX_CONFIG_PATH."users.xml") or die("Error: erreur fichier users.xml");
			foreach($deactivateVisitors->children() as $users) {
				if ( $users['profil'] =='5') {
					$users->attributes()->active = '0';
				}
			}
			$deactivateVisitors->asXml(PLX_ROOT.PLX_CONFIG_PATH."users.xml");
		}
		
        #code exécuté à l’activation du plugin 
        public function OnActivate() {
			$_SESSION['justactivated'.basename(__DIR__)] = true;
			
			#réactive compte visiteur s'il y en a
			$reactivateVisitors=simplexml_load_file(PLX_ROOT.PLX_CONFIG_PATH."users.xml") or die("Error: erreur fichier users.xml");
			foreach($reactivateVisitors->children() as $users) {
				if (( $users['profil'] =='5') and ( $users['active'] =='0') ) {
					$users->attributes()->active = '1';
				}
			} 
			$reactivateVisitors->asXml(PLX_ROOT.PLX_CONFIG_PATH."users.xml");
			# version >= 3.4.X 
			$plxMotor = plxMotor::getInstance();
			if(!file_exists($this->datasForums)) mkdir($this->datasForums, 0744);
			$oldatasForums =glob(PLX_ROOT.$plxMotor->aConf['racine_statiques'].'thread*.json');
			if(is_array($oldatasForums) && count($oldatasForums) > 0 ) {
				foreach($oldatasForums as $datas) {
					rename(realpath($datas), realpath($this->datasForums).'/'.basename($datas));
				}
			}
			
			$forumThreadFiles = glob($this->datasForums.'thread*.json');
			if(is_array($forumThreadFiles) && count($forumThreadFiles)>0) {			
				$userNames= array();
				$users = simplexml_load_file(PLX_ROOT.PLX_CONFIG_PATH."users.xml");
				foreach($users->children() as $user) {
					$key = $user->name->__toString();
					$num = $user->attributes()->number->__toString();
					$userNames[$key] = $num;
				}
				foreach($forumThreadFiles as $file) {
					$threads = $this->getFileDatas($file);
					foreach($threads as $k => $datas){
						# get $userNum value
						if(isset($userNames[$datas['name']])) $userNum = $userNames[$datas['name']];
						else $userNum = '001';// attribué à l'adminstrateur par défaut
						# update numUser
						if(!isset($datas['numUser'])) {
							$threads[$k]['numUser'] = $userNum;
						}
						elseif($datas['numUser'] =="" || $datas['numUser'] =="000") {
							$threads[$k]['numUser'] = $userNum;
						}
					}
					$this->saveJsonDatas($file,$threads);
				}
			}
		}	
		
		
        public function OnUpdate() {
            # code à exécuter à la mise à jour du plugin

			# transformation des dates en timestamps
			$forumThreadFiles = glob($this->datasForums.'thread*.json');
			if(is_array($forumThreadFiles) && count($forumThreadFiles)>0) {
				foreach($forumThreadFiles as $file) {
					$threads = $this->getFileDatas($file);
					foreach($threads as $k => $datas){
						if(!preg_match('/^[0-9]+$/', $datas['date'])) {
							# correction du format 
							$datas['date'] = str_replace('H',':',$datas['date']);
							# maj de la chaine date si necessaire
							if(!preg_match('/\\d{2}:\\d{2}$/', $datas['date'])) $datas['date'] = $datas['date'].'-12:00';
							# repasse la chaine en date
							$date =  DateTime::createFromFormat('d-m-Y-H:i', $datas['date']);
							# passe la date en timestamp pour enregistrement
							$timestamp = $date->getTimestamp();
							$threads[$k]['date'] = $timestamp;
						}
					}
					$this->saveJsonDatas($file,$threads);				
				}				
			}
		}

		public function AdminAuthEndHead(){
		?>
        <link rel="stylesheet" type="text/css" href="<?php echo PLX_PLUGINS . __CLASS__ ?>/css/auth.css" media="screen" />
        <?php
			if(isset($_SESSION['pageRequest'])) {
			?>
			<style>			
				h1.h5.text-center strong {display: none}
				h1.h5.text-center::before {content:'CONNEXION AU FORUM';display:block;}
			</style>
			<?php
			}
		}
        public function AdminAuthPrepend(){#save new on post
		echo '<?php #' . __CLASS__ . '::' . __FUNCTION__ . PHP_EOL; ?>
		ob_start();
        #New user
        if(!empty($_POST) AND !empty($_POST['update']) AND !empty($_POST['name']) AND !empty($_POST['wall-e']) AND !empty($_POST['password']) AND !empty($_POST['login']) AND empty($_POST['email'])) {
        $posts = array();
        $posts['userNum'] = array();
        $posts['newuser'] = 'true';
        $posts['update'] = $_POST['update'];
        # On récupère le dernier identifiant
        $a = array_keys($plxAdmin->aUsers);
        rsort($a);
        $new_userid = str_pad($a['0']+1, 3, "0", STR_PAD_LEFT);
        # On integre le nouvel utilisateur
        $posts['userNum'][] = $new_userid;
        $posts[$new_userid.'_newuser'] = 'true';
        $posts[$new_userid.'_name'] = $_POST['name'];
        $posts[$new_userid.'_infos'] = '';
        $posts[$new_userid.'_login'] = $_POST['login'];
        $posts[$new_userid.'_password'] = $_POST['password'];
        $posts[$new_userid.'_email'] = $_POST['wall-e'];#Real mail field ;)
        $posts[$new_userid.'_profil'] = PROFIL_FORUM;
        $posts[$new_userid.'_active'] = <?= $this->moderateSubscription ?>;
        $_SESSION['user'] = '1000';#need in editUsers()
        #On enregistre le nouvel utilisateur
        if(!$plxAdmin->editUsers($posts)) {
        $msgSignUp = $_SESSION['error'];
        unset($_SESSION['error'], $_POST['login'], $_POST['password']);
        $errorSignUp = 'alert red';
        }
        unset($_SESSION['user']);#remove fake
		if($posts[$new_userid.'_active'] =='0') {
		echo '<?php $this->lang('L_SUBSCRIPTION_PENDING') ?>';
		unset($_SESSION['profil']);
		exit;
		}
        }
        ?><?PHP
		}

        public function AdminAuthEndBody(){#get == 'new=1' or all
			echo self::BEGIN_CODE;
            echo '$label='.intval($this->getParam('label')).';';
		?>
        $formSignUpForum = '';
        if($plxAdmin->get == 'newMember=1') {# get == newMember=1
        ob_end_clean();
        define('L_BACK_SIGNUP_FORUM', '<?php $this->lang('L_BACK') ?>');
        define('L_SHIFT_SIGNUP_FORUM', '<?php $this->lang('L_SHIFT') ?>');
		define('L_PASSWORD_SIGNUP_FORUM', '<?php $this->lang('L_PASSWORD') ?>');
		include PLX_PLUGINS . '<?=__CLASS__?>' . DIRECTORY_SEPARATOR . 'form.signup.forum.php';
		unset($plxAdmin->get); 
		exit;
		}
		<?php
            echo self::END_CODE;
		}		
		
		#ajout constante profil VIP
		public function AdminPrepend() {
			if(!isset($plxShow->plxMotor->plxPlugins->aPlugins['vip_zone'])) {		
				echo self::BEGIN_CODE;
			?>
			const PROFIL_FORUM = 5;
			if(isset($_SESSION['profil']) && $_SESSION['profil'] > 4 && empty($_GET['d']) )  {
			if(isset($_SESSION['pageRequest'])) {
			$loc= $_SESSION['pageRequest'];
			unset($_SESSION['pageRequest']);
			echo header("location: ".$loc);
			die;
			}
			else {
			echo header("location:".PLX_ROOT);
			die;
			}
			}
			<?php
				echo self::END_CODE;
			}
		}		
		#On ajoute un profil utilisateur
        public function AdminUsersTop() {
			echo self::BEGIN_CODE;
		?>
		$plxMotor = plxMotor::getInstance();
		$plugin = $plxMotor->plxPlugins->aPlugins['<?= __CLASS__ ?>'];
		$VIP_Profil = $plugin->getLang('L_PROFIL_FORUM');				
		# Tableau des profils
		$aProfils[PROFIL_FORUM] = $VIP_Profil;
		<?php
            echo self::END_CODE;
		} 
		
	    #On renvoi le membre vers le forum demandé aprés authentification
        public function AdminTopEndHead() {
			if(!isset($plxShow->plxMotor->plxPlugins->aPlugins['vip_zone'])) {
				echo self::BEGIN_CODE;
			?>				 
			if(isset($_SESSION['profil']) && $_SESSION['profil'] == 5 && empty($_GET['d']) )  {
			if(isset($_SESSION['pageRequest'])) {
			$loc= $_SESSION['pageRequest'];
			unset($_SESSION['pageRequest']);
			echo header("location: ".$loc);
			die;
			}
			else {
			echo header("location:".PLX_ROOT);
			die;
			}
			}
			<?php
				echo self::END_CODE;
			}
		}
		
		public function ThemeEndBody() {
			echo '<?php  if($plxMotor->mode=="static") echo\'<script src="'.PLX_PLUGINS.__CLASS__.'/js/loadForm.js"></script>\'.PHP_EOL; ?>	';		
		}
		
		public function ThemeEndHead() {
			echo '<?php 
			if(file_exists(PLX_ROOT.$plxShow->plxMotor->aConf[\'racine_themes\'].$plxShow->plxMotor->aConf[\'style\'].\'/css/custom-'.__CLASS__.'\'))
			echo \'	<link href="\'.PLX_ROOT.$plxShow->plxMotor->aConf[\'racine_themes\'].$plxShow->plxMotor->aConf[\'style\'].\'/css/custom-'.__CLASS__.'.css" rel="stylesheet" type="text/css" />\'."\n"  ; 
			
			echo \'	<link href="'.PLX_PLUGINS.__CLASS__.'/css/site.css" rel="stylesheet" type="text/css" />\';
			?>';
			echo'<?php	
			if (!isset($_SESSION[\'profil\']) && ($plxMotor->mode === \'static\' )) $_SESSION[\'pageRequest\']= $_SERVER[\'REQUEST_URI\']; 
			
			?>';
			#gestion multilingue
			if(defined('PLX_MYMULTILINGUE')) {		
				$plxMML = is_array(PLX_MYMULTILINGUE) ? PLX_MYMULTILINGUE : unserialize(PLX_MYMULTILINGUE);
				$langues = empty($plxMML['langs']) ? array() : explode(',', $plxMML['langs']);
				$string = '';
				foreach($langues as $k=>$v)	{
					$url_lang="";
					if($_SESSION['default_lang'] != $v) $url_lang = $v.'/';
					$string .= 'echo "\\t<link rel=\\"alternate\\" hreflang=\\"'.$v.'\\" href=\\"".$plxMotor->urlRewrite("?'.$url_lang.$this->getParam('url').'")."\" />\\n";';
				}
				echo '<?php if($plxMotor->mode=="'.$this->getParam('url').'") { '.$string.'} ?>';
			}
			// ajouter ici aux besoins vos propre codes (insertion balises link, script , ou autre)
		}
		
		/**
			* Méthode qui affiche un message si le plugin n'a pas la langue du site dans sa traduction
			* Ajout gestion du wizard si inclus au plugin
			* @return	stdio
			* @author	Stephane F / G.Cyrille
		**/
		public function AdminTopBottom() {			
			echo '<?php
			
			error_reporting(E_ALL ^ E_NOTICE );
			$file = PLX_PLUGINS."'.$this->plug['name'].'/lang/".$plxAdmin->aConf["default_lang"].".php";
			if(!file_exists($file)) {
			echo "<p class=\\"warning\\">'.basename(__DIR__).'<br />".sprintf("'.$this->getLang('L_LANG_UNAVAILABLE').'", $file)."</p>";
			plxMsg::Display();
			}
			?>';
			
			# affichage du wizard à la demande
			if(isset($_GET['wizard'])) {$_SESSION['justactivated'.basename(__DIR__)] = true;}
			# fermeture session wizard
			if (isset($_SESSION['justactivated'.basename(__DIR__)])) {
				unset($_SESSION['justactivated'.basename(__DIR__)]);
				$this->wizard();
			}			
		}

		/** 
			* Méthode wizard
			* 
			* Descrition	: Affiche le wizard dans l'administration
			* @author		: G.Cyrille
			* 
		**/
		# insertion du wizard
		public function wizard() {
			# uniquement dans les page d'administration du plugin.
			if(basename(
			$_SERVER['SCRIPT_FILENAME']) 			=='parametres_plugins.php' || 
			basename($_SERVER['SCRIPT_FILENAME']) 	=='parametres_plugin.php' || 
			basename($_SERVER['SCRIPT_FILENAME']) 	=='plugin.php'
			) 	{	
				include_once(PLX_PLUGINS.__CLASS__.'/lang/'.$this->default_lang.'-wizard.php');
			}
		}
		
		/** 
			* Méthode plxShowStaticInclude
			* 
			* Descrition	:
			* @author		: TheCrok
			* 
		**/
		public function plxShowStaticContent() {
			# insertion des commentaires et formulaire			
			echo self::BEGIN_CODE;
		?>
		ob_start();
		if(isset($_GET['backHome'])) {
		$message=$_SESSION['msgcom'];
		$_SESSION = array();
		$_SESSION['msgcom']=$message;
		header('location: index.php?static'.$this->staticId().'/'.$this->staticTitle());
		exit;
		}
		include( PLX_PLUGINS.'StaticMiniForum/assets/commentaires.php');
		$output .= ob_get_clean();
		<?php
			echo self::END_CODE;
		}
		
		
		
		
		public function plxMotorPreChauffageEnd(){
		if(isset($_GET['RSS']) ){
			#est ce une page statique configurée pour un miniforum ?
			$var['statics']      = $this->getParam('statics')      == false||null ? '[]': $this->getParam('statics');
			$staticSelected      = json_decode($var['statics']);
			$parent=false;
			$plxShow = plxShow::getInstance();

			if(is_array($staticSelected) && in_array($plxShow->staticId(), $staticSelected) && str_pad($plxShow->staticId(), 3, '0', STR_PAD_LEFT) != $plxShow->plxMotor->aConf['homestatic'] ) {

            # fichier de stockages
            $sujets = $this->datasForums.'threads-'.$plxShow->staticId().'.json';
            $reponses = $this->datasForums.'threads-'.$plxShow->staticId().'-reply.json';
            $numRepliesBySubject = array();
            $threadsFile = $this->getFileDatas($sujets);
			$type='subject';
            
            array_multisort(array_column($threadsFile, 'date'), SORT_ASC, $threadsFile);
            $threadsFileReply =$this->getFileDatas($reponses);
            $replies = $threadsFileReply;
            $dataFile= PLX_ROOT.$sujets;
            
            foreach($replies as $k => $v) {
                if(isset($numRepliesBySubject[$v['subject']])) $numRepliesBySubject[$v['subject']] = ++$numRepliesBySubject[$v['subject']];
                else $numRepliesBySubject[$v['subject']] =1;
            }
            if(!empty($_GET['RSS'])) {
                $subjectRelated =  $threadsFile;
                foreach($subjectRelated as $index => $array) {
                    if($array['num'] === trim($_GET['RSS'])){
                        $subjectRelated = $array;
						$type='id-';
                        break;
                    }
                }
                $threadsFile = $threadsFileReply;
                $dataFile= PLX_ROOT.$reponses;
				$parent=trim($_GET['RSS']);
            } 
            # extraction des posts dans un tableau
            $threads =  $threadsFile;

		//$this->getFileDatas($file);
		$this->printRSSFeed($threads,$type,$parent);
	}

		}
		} 
		####################################
		######## Fonctions internes ########
		####################################
		
		/**
			* Methode getFileDatas
			*
			* creer le fichier si absent
			*
			* charge et decode json
			*
			* @author		: Gcyrillus
			*
		**/
		public function getFileDatas($file) {
			$file = $file;
			if(!file_exists($file) || strlen(trim(file_get_contents($file)))<1)  { 
				touch($file);
				file_put_contents($file,'[]');
			}
			$result = json_decode(file_get_contents($file), true);
			
			
			
			return $result;
		}
		
		
		/**
			* Methode SaveJsonDatas
			*
			* Enregistre les données au format json
			*
			* @author		: Gcyrillus
			*
		**/
		public function saveJsonDatas($file, $datas) {
			file_put_contents($file, json_encode($datas,true|JSON_PRETTY_PRINT) );		
		}
		
		/**
			* Methode updateDataUsers
			*
			* Ajoute le champ userNum avec le numero d'utilisateur
			*
			* @author		: Gcyrillus
			*
		**/
		public function updateDataUsers() {


		}
		
		/** 
			* Méthode HTMLbadge
			* 
			* Descrition	: Extrait capitale(s) et/ ou premiers lettres du nom du membre
			*				  Extrait une couleur $colors
			*				  creer un badge avec $HTMLletterBadge 
			* @author		: Gcyrillus
			* 
		**/		
		public 	function HTMLbadge($string,$patternColors, $HTMLletterBadge){
			$av='';
			$num4color=1;
			$alphabet = range('A', 'Z');
			$letters=preg_split("/(?=[A-Z])/", ucwords($string),-1);
			foreach($letters as $k) {
				$av .= mb_substr(trim($k), 0,1);
				$num4color = ($num4color + array_search(strtoupper($k), $alphabet));
			}
			$dataReplace=array('#bgColor','#size','#ucWL','#member');
			$replaceBy =array($patternColors[substr($num4color, -1)],3.5 / strlen(substr($av,0,3)),substr($av,0,3),$string);
			return str_replace($dataReplace, $replaceBy, $HTMLletterBadge).PHP_EOL;
		}
		
		/** 
			* Méthode patternToRGB
			* 
			* Descrition	: renvoi une image pour chaque pattern de couleur
			*
			* @author		: Gcyrillus
			* 
		**/		
		public function patternToRGB($pattern) {
			$bg=$pattern[0];
			$pattern =array_reverse($pattern);
			$pattern[]=$bg;
			$image = imagecreatetruecolor(200,20);
			$step=200;
			
			# ajout block couleurs
			foreach($pattern as $block ) {
				list($r,$g,$b) = array_map('hexdec', str_split(ltrim($block,'#'), 2));
				imagefilledrectangle($image, $step , 0 , 20, 20 ,	imagecolorallocate($image,$r,$g,$b ));
				$step = $step-20;
			}
			# renvoi l'image dans une balise <img src="data:image/image/png;base64,...">
			ob_start();
			imagePng($image);
			$base_64 = base64_encode(ob_get_clean());
			imagedestroy($image);			
			return '<img src="data:image/image/png;base64,'.$base_64.'">';
		}
		
		
		/* hook 
			*
			* capte les dernieres action du forum
			*
		*/
		public function lastThreads($admins=true) {
			# récupération d'une instance de plxShow
			$plxShow = plxShow::getInstance();
			# récupération d'une instance de plxMotor
			$plxMotor = plxMotor::getInstance();
			echo '		<div class="lastThreads">';
			# recupere les sujets
			$threadsS = glob($this->datasForums.'thread*[!reply].json');
			$forums=array();
			$forumLink=array();
			$forumThreads = array();
			foreach($threadsS as $subject) {
				
				# lien vers le forum 
				preg_match_all('!\d!', $subject, $matches);
				$statid=implode('',$matches[0]);
				$statnum =str_pad($statid,3,'0',STR_PAD_LEFT);
				
				#si la page statique n'existe pas, on zappe
				if(!isset($plxMotor->aStats[$statnum])) {
					continue;
				} 
				
				
				$statiqueUrl= $plxMotor->urlRewrite('?static'.$statid.'/'.$plxMotor->aStats[$statnum]['url']);
				$statiqueName = $plxMotor->aStats[$statnum]['name'];
				
				# récupération des sujets
				$content = json_decode( file_get_contents($subject),true );
				$active='';
				if($plxMotor->mode == 'static' && $statid == $plxShow->staticId()) $active='class="active"';
				if(count($content)>0)
				$forumLink[]='			<li '.$active.'><a href="'.$statiqueUrl.'#forum_posts">'.$statiqueName.'</a></li>'.PHP_EOL;
				
				# on zappe les forums vides
				if(!is_array($content)) continue;
				$content = array_reverse($content);
				foreach($content as $k => $sujet) {
					if($sujet['content'] =='')continue;
					# création des liens vers sujet
					$id='#thread-'.$sujet['num'];
					$url='		<li><a href="'.$statiqueUrl.$id.'" title="'.$sujet['subject'].': '.
					plxUtils::truncate($this->removeMarkdown($sujet['subject']), 45, '...', true, false)
					.'"><b>'.$sujet['name'].'</b>: '.
					plxUtils::truncate($this->removeMarkdown($sujet['subject']), 25, '...', true, false)
					.'</a></li>'.PHP_EOL;
					#stockage par  la date
					$forumThreads[$sujet['date']][$id] = $url; 
				}		
			}
			
			
			# Affichage vers les autres forum si plus d'un.
			$otherForums='';
			if($this->getParam('otherForums') && $this->getParam('otherForums') == 1 && count($forumLink) >1){
				
				$otherForums='
				<h4>'.$this->getLang('L_OTHER_FORUMS').'</h4>
				<ul  class="other-forum-list unstyled-list">';
				foreach($forumLink as $link) {
					$otherForums .=$link.PHP_EOL;
				}
				$otherForums .='
				</ul>'.PHP_EOL;
			}
			
			# Affichage des derniers sujets
			$derniersujet='';
			
			krsort($forumThreads);
			$i=50;
			if($this->getParam('notificationNb')) {
				$limit= $this->getParam('notificationNb');
				$i = 0;
			} 
			foreach($forumThreads as $date => $id){
				krsort($id);
				foreach($id as $li){
					if($i >= $limit) break;
					$derniersujet .= $li;
					++$i;
				}
			}
			if($derniersujet=='') $derniersujet= '<li>'.$this->getLang('L_NONE').'</li>';
			echo '	<h3>'.$this->getLang('L_FROM_FORUM').' <span class="nbMembers">'.count($plxMotor->aUsers).' '.$this->getLang('L_USERS').'</span></h3>
			<h4>'.$this->getLang('L_LAST_SUBJECT').'</h4>'.PHP_EOL.'
			<ul class="forum-subject-list unstyled-list">'.$derniersujet.'</ul>'.PHP_EOL;
			
			# récupére les réponses
			$threadsR = glob($this->datasForums.'thread*[reply].json');
			$forumThreadsR=array();
			
			foreach($threadsR as $response) {
				
				# lien vers le forum 
				preg_match_all('!\d!', $response, $matches);
				$statid=implode('',$matches[0]);
				$statnum =str_pad($statid,3,'0',STR_PAD_LEFT);
				
				#si la page statique n'existe pas, on zappe
				if(!isset($plxMotor->aStats[$statnum])) {
					// unlink($response);
					continue;
				}
				
				$statiqueUrl= $plxMotor->urlRewrite('?static'.$statid.'/'.$plxMotor->aStats[$statnum]['url']);
				$statiqueName = $plxMotor->aStats[$statnum]['name'];
				
				# récupération des reponses
				$reponses = json_decode( file_get_contents($response),true );
				
				# on zappe les forums vides
				if(!is_array($reponses)) continue;
				$content = array_reverse($reponses);
				foreach($reponses as $k => $reponse) {
					if($reponse['content'] =='')continue;
					# création des liens vers sujet
					$id='&replies='.$reponse['subject'].'#id-'.$reponse['num'];
					
					$url='		<li><a href="'.$statiqueUrl.$id.'" title="'.$statiqueName.': '.
					plxUtils::truncate($this->removeMarkdown($reponse['content']), 75, '...', true, false)
					.'"><b>'.
					$reponse['name']
					.'</b>: '.plxUtils::truncate($this->removeMarkdown($reponse['content']), 25, '...', true, false).'</a></li>'.PHP_EOL;
					#stockage par  la date
					$forumThreadsR[$reponse['date']][$id] = $url; 
				}		
			}
			# Affichage des dernieres réponses
			$derniersujet='';
			
			krsort($forumThreadsR);
			$i=50;
			if($this->getParam('notificationNb')) {
				$limit= $this->getParam('notificationNb');
				$i = 0;
			} 
			foreach($forumThreadsR as $date => $id){
				krsort($id);
				foreach($id as $li){
					if($i >= $limit) break;
					$derniersujet .= $li;
					++$i;
				}
			}
			if($derniersujet=='')$derniersujet= '		<li>'.$this->getLang('L_NONE_IN_LIST').'</li>'.PHP_EOL;
			echo '
			<h4>'.$this->getLang('L_LAST_REPLY').'</h4>'.PHP_EOL.'
			<ul class="forum-response-list unstyled-list">'.$derniersujet.'</ul>
			'.$otherForums.PHP_EOL.'
			'.$this->getModos($admins).'
			</div>'.PHP_EOL;			
		}
		
		public function getModos($admins) {
			if($admins==true){
				# récupération d'une instance de plxMotor
				$plxMotor = plxMotor::getInstance();
				$profilModo= array("0","1","2");
				$modos =PHP_EOL.'			<p class="modos">'.$this->getLang('L_FORUM_MODERATOR').': ';
				foreach($plxMotor->aUsers as $user => $data) {
					if($data['delete']==1 || $data['active']==0)continue;
					if(in_array($data['profil'],$profilModo))
					$modos .= '<span><b>'.$data['name'].'</b>: '.$this->memberProfils[$data['profil']].' </span> '.PHP_EOL;
				}
				$modos .='</p>'.PHP_EOL;
				return $modos;
			}
		}
		
		public function printRSSFeed($datas,$type,$parent) {
		#on charge plxShow
		$plxShow = plxShow::getInstance();

		# identification de la page
		$statId = $plxShow->staticId();
		$title = $plxShow->plxMotor->aConf['title'].' - MiniForum: '.$plxShow->plxMotor->aStats[$plxShow->plxMotor->cible]['name'];
		$mainDescription ='MiniForum: '.$plxShow->plxMotor->aStats[$plxShow->plxMotor->cible]['name'];
		$itemTitle = $plxShow->plxMotor->aStats[$plxShow->plxMotor->cible]['name'].' ';
		$link = $plxShow->plxMotor->urlRewrite('?static'.$plxShow->staticId().'/'.$plxShow->plxMotor->aStats[$plxShow->plxMotor->cible]['url']);
		$parentDesc='';

			if($parent > 0){
				$parentDatas=$this->getFileDatas($this->datasForums.'threads-'.$plxShow->staticId().'.json');
				$subjectKeyParent = array_search($parent, array_column($parentDatas, 'num'));
				$parentDesc = plxUtils::truncate($parentDatas[$subjectKeyParent]['subject'], 145, '...', true, false);
				$title= $plxShow->plxMotor->aConf['title'].' - MiniForum - '.$this->getLang('L_SUBJECT_CONTENT').': '.$parentDesc;
				$mainDescription = $title;
			}
		# items du flux 
		$entry='';
		$feedLength=0;
		foreach($datas as $k => $v)  {
		$feedLength++;
		if(!isset($pubdate) && !isset($parent)) $pubdate =plxDate::dateIso2rfc822(date('YmdHi',$v["date"]));
			$linkParent ='';
			$numReplie = $v['num'];
			$go=false;
			# identification de la page du flux	
			if($v['subject'] == $parent) {
				$type = $type.$v['num'];
				$linkParent ='&replies='.$v['num'].'#subject';
				foreach($parentDatas as $pk => $pv){
				if(!isset($pubdate)) $pubdate =plxDate::dateIso2rfc822(date('YmdHi',$v["date"]));
					if($pv['num'] === $parent && $parent === $v['subject']) {
						$numReplie = $parent;
					}
				}

			}
			if($linkParent!=='') {$itemTitle = $plxShow->plxMotor->aStats[$plxShow->plxMotor->cible]['name'].': '.$this->getLang('L_REPLY').' N°'.$v['num'];}
			if(isset($parent) && $parent > 0 && $v['subject'] !== $parent) continue;
			else {$itemTitle = $plxShow->plxMotor->aStats[$plxShow->plxMotor->cible]['name'].': '.$this->getLang('L_SUBJECT_CONTENT').': '.plxUtils::truncate($v['subject'], 145, '...', true, false);}
			# ajout des items

			$entry .= "\t<item>\n";
			$entry .= "\t\t".'<title>'. $itemTitle.'</title> '."\n";
			$entry .= "\t\t".'<link>'.$link.'&replies='.$numReplie.'#'.$type.'</link>'."\n";
			$entry .= "\t\t".'<guid>'.$link.'&replies='.$numReplie.'#'.$type.'</guid>'."\n";
			$entry .= "\t\t".'<description>'.plxUtils::strCheck(plxUtils::rel2abs(PLX_ROOT,$v["content"])).'</description>'."\n";
			$entry .= "\t\t".'<pubDate>'.plxDate::dateIso2rfc822(date('YmdHi',$v["date"])).'</pubDate>'."\n";
			$entry .= "\t\t".'<dc:creator>'.$v["name"].'</dc:creator>'."\n";
			$entry .= "\t</item>\n";
			
			if($feedLength == $plxShow->plxMotor->aConf['bypage_feed']) break;
		}
		if(!isset($pubdate)) $pubdate= plxDate::dateIso2rfc822(date('YmdHi'));
		# On affiche le flux
		header('Content-Type: application/rss+xml; charset='.PLX_CHARSET);
		echo '<?xml version="1.0" encoding="'.PLX_CHARSET.'" ?>'."\n";
		echo '<rss version="2.0" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:atom="http://www.w3.org/2005/Atom">'."\n";
		echo '<channel>'."\n";
		echo "\t".'<title>'.plxUtils::strCheck($title).'</title>'."\n";
		echo "\t".'<link>'.$link.$linkParent.'</link>'."\n";
		echo "\t".'<language>' . $plxShow->plxMotor->aConf['default_lang'] . '</language>'."\n";
		echo "\t".'<description>'.$mainDescription.'</description>'."\n";
		echo "\t".'<atom:link xmlns:atom="http://www.w3.org/2005/Atom" rel="self" type="application/rss+xml" href="'.$link.'" />'."\n";
		echo "\t".'<lastBuildDate>'.$pubdate.'</lastBuildDate>'."\n";
		echo "\t".'<generator>StaticMiniForum</generator>'."\n";
		echo $entry;
		echo '</channel>'."\n";
		echo '</rss>';	

		# fin des scripts
		exit;
		}
		
		public function removeMarkdown($string) {
		
				# nettoyage ratrapage markdown dans les liens
				$patterns= array(
				0=>'/[#]/',
				1=>'/`/',
				2=>'/~/',
				3=>'/\*/',
				4=>'/___/',
				5=>'/|/',
				6=>'/|/',
				7=>'/:-/',
				8=>'/-:/',
				9=>'/&039;/',
				);
				$patternsRemoved= array(
				0=>'',
				1=>'',
				2=>'',
				3=>'',
				4=>'',
				5=>'',
				6=>'',
				7=>'',
				8=>'',
				9=>'&#039;',
				);
				
				return preg_replace($patterns, $patternsRemoved, $string);
				
		}
	}														